#include "hard_com.h"
void I2C_PIN_CNF(int I2C_Clock_KHz){
	    #ifdef I2C0_EN 
					if (I2C_Clock_KHz>400)
					LPC_PINCON->I2CPADCFG=1010;
					LPC_PINCON->PINSEL1|=(1<<24);
					LPC_PINCON->PINSEL1|=(1<<22);
					LPC_PINCON->PINMODE_OD0|=(1<<28);
					LPC_PINCON->PINMODE_OD0|=(1<<27);
					#undef I2C0_EN 
	    #endif
			
			#ifdef I2C1_EN
					LPC_PINCON->PINSEL0|=(3<<2);
					LPC_PINCON->PINSEL0|=(3<<0);
					LPC_SC->PCONP |= (1 << 19);
					LPC_PINCON->PINMODE_OD0|=(1<<1);
					LPC_PINCON->PINMODE_OD0|=(1<<0);
					#undef I2C1_EN
      #endif
			#ifdef I2C2_EN
					LPC_PINCON->PINSEL0|=(2<<20);
					LPC_PINCON->PINSEL0|=(2<<22);
					LPC_SC->PCONP |= (1 << 26);
					LPC_PINCON->PINMODE_OD0|=(1<<10);
					LPC_PINCON->PINMODE_OD0|=(1<<11);
					#undef I2C2_EN
      #endif
}

//***************************************************************
 void I2C_Init(int I2C_Clock_KHz, LPC_I2C_TypeDef *I2CX){
	    int clk_reg_temp;
	
	    I2C_PIN_CNF(I2C_Clock_KHz);
	
     //Clock Calculations
	    I2C_Clock_KHz*=1000;
	    clk_reg_temp=Peripheral_Clock/(I2C_Clock_KHz*2);//Go to page 448 of users Manual
     //Set The Values
	    I2CX->I2SCLL=clk_reg_temp;
	    I2CX->I2SCLH=clk_reg_temp;
	    I2CX->I2CONCLR = 255; // Clear All The Bits   
	    I2CX->I2CONSET=(1<<6);// Enable the I2C Block
	
}

int MPU_Read(unsigned char MPU_ADDRR,unsigned char REG_ADR,unsigned char n , unsigned char *Data,LPC_I2C_TypeDef *I2CX ){
	   int i; 
	   unsigned char crc[3];
	   I2CX->I2CONSET=(1<<5);												//transmit a start condition
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
	    crc[0]=I2CX->I2STAT;           							//must be 0x18 to show success
	    LPC_I2C0->I2DAT=(((MPU_Addr)<<1)|Write);		//load the address+r/w
			I2CX->I2CONCLR =(1<<5);										  //clear start bit
	    I2CX->I2CONCLR =(1<<3);											//clear IS
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
	    crc[1]=I2CX->I2STAT;           							//must be 0x28 to show success 
	    LPC_I2C0->I2DAT=(REG_ADR);						    	//Load the Register Address 
	    I2CX->I2CONCLR =(1<<3); 					      		//clear start and SI bits
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
		  crc[2]=I2CX->I2STAT;           				  	  //must be 0x28 to show success 
	     I2CX->I2CONSET=(1<<5);
	    I2CX->I2CONCLR =(1<<3); 
	
while(~I2CX->I2CONSET&(1<<3));                //Now the Re-start has been transmited

      crc[0]=I2CX->I2STAT;           							//must be 0x18 to show success
	    LPC_I2C0->I2DAT=(((MPU_Addr)<<1)|Read);		//load the address+r/w
			I2CX->I2CONCLR =(1<<5);										  //clear start bit
	    I2CX->I2CONCLR =(1<<3);                     //Clear the SI bit
			
while(~I2CX->I2CONSET&(1<<3));               //Now the address +r/w is transmited

			I2CX->I2CONSET=(1<<2);                       // Set The AA bit
			for(i=0;i<n-1;i++){
			I2CX->I2CONCLR =(1<<3);                     //Clear the SI bit
      while(~I2CX->I2CONSET&(1<<3)); 
				*(Data+i)=I2CX->I2DATA_BUFFER;
			}
		  I2CX->I2CONCLR =(1<<3)|(1<<2);                     //Clear the SI bit
while(~I2CX->I2CONSET&(1<<3)); 
			
      *(Data+i)=I2CX->I2DATA_BUFFER;                  //get the value
			I2CX->I2CONCLR =(1<<3);                     //Clear the SI bit
	    I2CX->I2CONSET=(1<<4);											//stop send

    if( (crc[0]==24) && (crc[1]==40) && (crc[2]==40) )
	  return 1;  
	  else
    return 0;			
}
int MPU_Write(unsigned char MPU_ADDRR,unsigned char REG_ADR,unsigned char Data, LPC_I2C_TypeDef *I2CX){
	    
	   unsigned char crc[3];
	   I2CX->I2CONSET=(1<<5);												//transmit a start condition
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
	    crc[0]=I2CX->I2STAT;           							//must be 0x18 to show success
	    LPC_I2C0->I2DAT=(((MPU_Addr)<<1)|Write);		//load the address+r/w
			I2CX->I2CONCLR =(1<<5);										  //clear start bit
	    I2CX->I2CONCLR =(1<<3);											//clear IS
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
	    crc[1]=I2CX->I2STAT;           							//must be 0x28 to show success 
	    LPC_I2C0->I2DAT=(REG_ADR);						    	//Load the Register Address 
	    I2CX->I2CONCLR =(1<<3); 					      		//clear start and SI bits
	
while(~LPC_I2C0->I2CONSET&(1<<3));
	
	    LPC_I2C0->I2DAT=(Data);                     //Load the data  
		  crc[2]=I2CX->I2STAT;           				  	  //must be 0x28 to show success 
	    I2CX->I2CONCLR =(1<<3); 
	
while(~LPC_I2C0->I2CONSET&(1<<3));

	    I2CX->I2CONCLR =(1<<3);                     //Clear the SI bit
	    I2CX->I2CONSET=(1<<4);											//stop send
   if( (crc[0]==24) && (crc[1]==40) && (crc[2]==40) )
	  return 1;  
	  else
    return 0;		
}
